package org.netkernel.lang.javascript;

import org.mozilla.javascript.Context;
import org.mozilla.javascript.ContextFactory;
import org.mozilla.javascript.Script;
import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer1.representation.IDeterminateStringRepresentation;
import org.netkernel.module.standard.endpoint.StandardTransreptorImpl;

public class JavascriptCompiler extends StandardTransreptorImpl
{
	public JavascriptCompiler()
	{	this.declareThreadSafe();
		this.declareToRepresentation(Script.class);
	}

	@Override
	public void onTransrept(INKFRequestContext context) throws Exception
	{	IDeterminateStringRepresentation ds=context.sourcePrimary(IDeterminateStringRepresentation.class);
		Context jsContext=null;
		try
		{	jsContext=ContextFactory.getGlobal().enterContext();
			Script s=jsContext.compileString(ds.getString(), context.getThisRequest().getIdentifier(), 1, null);
			context.createResponseFrom(s);
		}
		finally
		{	if(jsContext!=null)
			{	Context.exit();
			}
		}
	}
}
